extends ../layouts/navbar
include ../components/successerrorbox
include ../components/deleteform
include ../components/endbeforestartvalidation
include ../components/deleteform

block content
    h1 Quiz Overview
    +successerror(sucmsg, errmsg)

    .container-fluid.p-0
        .row
            .col
                .row
                    .col
                        .card
                            .card-header Summary
                            .card-body
                                .container
                                    .row
                                        .col-2
                                            h6 Name:
                                        .col= data.name
                                        .col-3
                                            h6 Quiz Type
                                        .col= data.quiztypeName
                                    .row
                                        .col-2
                                            h6 Max Score:
                                        .col= (data.totalscore) ? data.totalscore : "Based on questions in quiz"
                                        .col-3
                                            h6 Questions in Quiz:
                                        .col= data.qncount
                .row.mt-2
                    .col.pr-1
                        .card
                            .card-header Quiz Description
                            .card-body.test-case-height !{(data.description) ? data.description : "No description"}
                    .col.pl-1
                        .card
                            .card-header Instructions to Quiz Takers
                            .card-body.test-case-height !{(data.preinstructions) ? data.preinstructions : "No Instructions"}
                .row.mt-2
                    .col
                        .card
                            .card-header Time Settings
                            .card-body
                                .container
                                    .row
                                        .col-2
                                            h6 Start Time:
                                        .col
                                            if (data.timestart !== "Invalid date")
                                                span= data.timestart
                                            else
                                                span.text-danger No Start Time (REQUIRED)
                                        unless (data.quiztype === 2)
                                            .col-3
                                                h6 End Time:
                                            .col= (data.timeend) ? data.timeend : "No End Time"
                                        else
                                            .col-3
                                                h6 End Time:
                                            .col= (data.timeend) ? data.timeend : "No End Time"
                                    .row
                                        if (data.quiztype === 0)
                                            .col-2
                                                h6 Duration:
                                            .col= (data.timelimit) ? data.timelimit : "No Time Limit"
                                        if (data.quiztype === 0 || data.quiztype === 1)
                                            .col-3
                                                h6 Attempts:
                                            .col= (data.attempts) ? data.attempts : "Unlimited Attempts"
                .row.mt-2
                    .col
                        .card
                            .card-header Quiz Security Settings
                            .card-body
                                .container
                                    .row
                                        if (data.passwordgen || data.password)
                                            .col-2
                                                h6 Enabled:
                                            .col Yes
                                            if (data.passwordgen)
                                                .col-2
                                                    h6 Password:
                                                .col Randomly Generated
                                            else
                                                .col-3
                                                    h6 Password:
                                                .col= data.password
                                        else
                                            .col-2
                                                h6 Enabled:
                                            .col No
                                    if (data.passwordgen)
                                        .row
                                            .col-2
                                                h6 OTP Expiry Time (Seconds):
                                            .col= data.otptimelimit
                .row.mt-2
                    .col
                        .card
                            .card-header Completion Reporting
                            .card-body
                                .container.p-0
                                    .row
                                        .col
                                            h6.card-subtitle.mb-2.text-muted Whether to show Quiz Takers any of the following:
                                    .row
                                        .col-2
                                            h6 Show Grade:
                                        .col
                                            case (data.showgrade)
                                                when 0
                                                    span Never
                                                when 1
                                                    span After Quiz Attempt
                                                when 2
                                                    span After Quiz Closes
                                        .col-2
                                            h6 Show Report:
                                        .col
                                            case (data.studentreport)
                                                when 0
                                                    span Never
                                                when 1
                                                    span After Quiz Attempt
                                                when 2
                                                    span After Quiz Closes
            .col-3
                form(action=`/course/info/${courseid}/${quizid}/save`, method='post')
                    .row
                        .col
                            button.btn.btn-primary(type='submit').w-100 Save
                    .row.mt-2
                        .col
                            a.btn.btn-danger(href=`/course/info/${courseid}?edit=1`).w-100 Cancel
                .row.mt-3
                    .col
                        .card
                            .card-header Actions
                            .card-body
                                ul.list-group.list-group-flush
                                    button.config-quiz(type="button", data-href=`/course/info/${courseid}/${quizid}/edit/info`).list-group-item.list-group-item-action Change Information/Type
                                    button.config-quiz(type="button", data-href=`/course/info/${courseid}/${quizid}/edit/date`).list-group-item.list-group-item-action Change Duration
                                    button.config-quiz(type="button", data-href=`/course/info/${courseid}/${quizid}/edit/security`).list-group-item.list-group-item-action Change Security Settings
                                    button.config-quiz(type="button", data-href=`/course/info/${courseid}/${quizid}/edit/completion`).list-group-item.list-group-item-action Change Completion Reporting Settings
                                    a(href=`/course/info/${courseid}/${quizid}/questions`).list-group-item.list-group-item-action Manage Questions
                if quizid !== "-1"
                    .row.mt-2
                        .col
                            +deleteForm(`/course/info/${courseid}/delete/${quizid}`, 'deleteQuiz', `You are about to delete this quiz (${data.name}). Are you sure you want to continue? This action cannot be reversed!`, 'Delete Quiz', true)

    // IFrame to load configs
    .modal.fade#configModal(tabindex="-1", role="dialog", aria-labelledby="pwGenTitle", aria-hidden=true)
        .modal-dialog.modal-dialog-centered(role="document").modal-xl
            .modal-content.h-100
                .modal-header
                    h5.modal-title#configTitle Configuration (WIP)
                    button(type="button", data-dismiss="modal", aria-label="Close").close
                        span(aria-hidden="true") &times;
                .modal-body.h-75
                    iframe#quizFrame(onload="setIframeHeight(this.id)", frameborder="0").w-100.no-overflow-x
                .modal-footer
                    button.btn.btn-primary(type="button")#updateQuizConfigBtn Update Quiz
                    button.btn.btn-danger(type="button", data-dismiss="modal") Close
    script.
        let iframeObj = $("#quizFrame");
        let iframetitle = $("#configTitle");
        $(".config-quiz").click((e) => {
            iframeObj.attr('src', $(e.target).data('href') + "?iframe=1"); // Update iframe
            iframeObj.hide();
            iframetitle.text("Loading Settings...")
            $("#configModal").modal();
        });
        $("#updateQuizConfigBtn").click(() => {
            // Run iframe (#editConfigForm) and submit form
            let form = iframeObj.contents().find("#editConfigForm");
            // Submit the form
            if (!basicValidation(form)) return;
            $.ajax({
                url: form.attr('action') + "?iframe=1",
                type: 'POST',
                data: form.serialize(),
                success: function (data) {
                    if (data.success) window.location.href = data.redirect;
                }
            });
        });

        function basicValidation(form) {
            // Leeched from formvalidation.pug
            let result = true;
            if (form[0].checkValidity() === false) result=false;
            form[0].classList.add('was-validated');
            return result;
        }

        function setIframeHeight(id, init=true) {
            if (init) {
                iframeObj.show();
                iframetitle.text(iframeObj.contents().find("#typeTitle").text());
                iframeObj.contents().find(".resize-frame").click(() => setIframeHeight(id, false));
            }
            let ifrm = document.getElementById(id);
            let doc = ifrm.contentDocument ? ifrm.contentDocument : ifrm.contentWindow.document;
            ifrm.style.visibility = 'hidden';
            ifrm.style.height = "10px"; // reset to minimal height ...
            ifrm.style.height = getDocHeight(doc) + 4 + "px"; // IE opt. for bing/msn needs a bit added or scrollbar appears
            $('#configModal').modal('handleUpdate');
            ifrm.style.visibility = 'visible';
        }

        function getDocHeight(doc) {
            doc = doc || document; // stackoverflow.com/questions/1145850/
            let body = doc.body, html = doc.documentElement;
            return Math.max(body.scrollHeight, body.offsetHeight, html.clientHeight, html.scrollHeight, html.offsetHeight);
        }
